com.fasterxml.jackson.databind.deser.std

## Class EnumSetDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<T>
  - - com.fasterxml.jackson.databind.deser.std.StdDeserializer<EnumSet<?>>
    - - com.fasterxml.jackson.databind.deser.std.EnumSetDeserializer

- All Implemented Interfaces:
    ContextualDeserializer, NullValueProvider, Serializable

      public class EnumSetDeserializer
      extends StdDeserializer<EnumSet<?>>
      implements ContextualDeserializer

  Standard deserializer for `EnumSet`s.

  Note: casting within this class is all messed up -- just could not figure out a way to properly deal with recursive definition of "EnumSet<K extends Enum<K>, V>

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `JsonDeserializer.None`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Class<Enum>` | `_enumClass`
    `protected JsonDeserializer<Enum<?>>` | `_enumDeserializer`
    `protected JavaType` | `_enumType`
    `protected Boolean` | `_unwrapSingle` Specific override for this instance (from proper, or global per-type overrides) to indicate whether single value may be taken to mean an unwrapped one-element array or not.

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_valueClass, F_MASK_ACCEPT_ARRAYS, F_MASK_INT_COERCIONS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `EnumSetDeserializer(EnumSetDeserializer base, JsonDeserializer<?> deser, Boolean unwrapSingle)`
    `` | `EnumSetDeserializer(JavaType enumType, JsonDeserializer<?> deser)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected EnumSet<?>` | `_deserialize(JsonParser p, DeserializationContext ctxt, EnumSet result)`
    `JsonDeserializer<?>` | `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
    `EnumSet<?>` | `deserialize(JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
    `EnumSet<?>` | `deserialize(JsonParser p, DeserializationContext ctxt, EnumSet<?> result)` Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer.
    `Object` | `deserializeWithType(JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Base implementation that does not assume specific type inclusion mechanism.
    `protected EnumSet<?>` | `handleNonArray(JsonParser p, DeserializationContext ctxt, EnumSet result)`
    `boolean` | `isCachable()` Because of costs associated with constructing Enum resolvers, let's cache instances by default.
    `Boolean` | `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.
    `EnumSetDeserializer` | `withDeserializer(JsonDeserializer<?> deser)`
    `EnumSetDeserializer` | `withResolved(JsonDeserializer<?> deser, Boolean unwrapSingle)`

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.std.StdDeserializer

      `_byteOverflow, _coercedTypeDesc, _coerceEmptyString, _coerceIntegral, _coerceNullToken, _coerceTextualNull, _deserializeFromArray, _deserializeFromEmpty, _deserializeWrappedValue, _failDoubleToIntCoercion, _findNullProvider, _hasTextualNull, _intOverflow, _isEmptyOrTextualNull, _isIntNumber, _isNaN, _isNegInf, _isPosInf, _neitherNull, _nonNullNumber, _parseBooleanFromInt, _parseBooleanPrimitive, _parseBytePrimitive, _parseDate, _parseDate, _parseDateFromArray, _parseDoublePrimitive, _parseDoublePrimitive, _parseFloatPrimitive, _parseFloatPrimitive, _parseIntPrimitive, _parseIntPrimitive, _parseLongPrimitive, _parseLongPrimitive, _parseShortPrimitive, _parseString, _reportFailedNullCoerce, _shortOverflow, _verifyEndArrayForSingle, _verifyNullForPrimitive, _verifyNullForPrimitiveCoercion, _verifyNullForScalarCoercion, _verifyNumberForScalarCoercion, _verifyStringForScalarCoercion, findContentNullProvider, findContentNullStyle, findConvertingContentDeserializer, findDeserializer, findFormatFeature, findFormatOverrides, findValueNullProvider, getValueClass, getValueType, handledType, handleMissingEndArrayForSingle, handleUnknownProperty, isDefaultDeserializer, isDefaultKeyDeserializer, parseDouble`

    - ### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

      `findBackReference, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, getObjectIdReader, replaceDelegatee, unwrappingDeserializer`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _enumType

          protected final JavaType _enumType

    - #### _enumClass

          protected final Class<Enum> _enumClass

    - #### _enumDeserializer

          protected JsonDeserializer<Enum<?>> _enumDeserializer

    - #### _unwrapSingle

          protected final Boolean _unwrapSingle

      Specific override for this instance (from proper, or global per-type overrides) to indicate whether single value may be taken to mean an unwrapped one-element array or not. If null, left to global defaults.
      Since:
        2.7

  - ### Constructor Detail

    - #### EnumSetDeserializer

          public EnumSetDeserializer(JavaType enumType,
                                     JsonDeserializer<?> deser)

    - #### EnumSetDeserializer

          protected EnumSetDeserializer(EnumSetDeserializer base,
                                        JsonDeserializer<?> deser,
                                        Boolean unwrapSingle)

      Since:
        2.7

  - ### Method Detail

    - #### withDeserializer

          public EnumSetDeserializer withDeserializer(JsonDeserializer<?> deser)

    - #### withResolved

          public EnumSetDeserializer withResolved(JsonDeserializer<?> deser,
                                                  Boolean unwrapSingle)

    - #### isCachable

          public boolean isCachable()

      Because of costs associated with constructing Enum resolvers, let's cache instances by default.
      Overrides:
        `isCachable` in class `JsonDeserializer<EnumSet<?>>`

    - #### supportsUpdate

          public Boolean supportsUpdate(DeserializationConfig config)

      Description copied from class: `JsonDeserializer`
      Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

      Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserialization construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

      Default implementation returns `null` to allow explicit per-type or per-property attempts.

      Overrides:
        `supportsUpdate` in class `JsonDeserializer<EnumSet<?>>`

    - #### createContextual

          public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                      BeanProperty property)
                                               throws JsonMappingException

      Description copied from interface: `ContextualDeserializer`
      Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.
      Specified by:
        `createContextual` in interface `ContextualDeserializer`
      Parameters:
        `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
        `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
      Returns:
        Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
      Throws:
        `JsonMappingException`

    - #### deserialize

          public EnumSet<?> deserialize(JsonParser p,
                                        DeserializationContext ctxt)
                                 throws IOException

      Description copied from class: `JsonDeserializer`
      Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

      Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

      The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

                {
                    "@class": "class name",
                    ...
                }

      Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

                 if (p.getCurrentToken() == JsonToken.START_OBJECT) {
                   p.nextToken();
                 }

      This results in the stream pointing to the field name, so that the two conditions align.

      Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

      Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

      Specified by:
        `deserialize` in class `JsonDeserializer<EnumSet<?>>`
      Parameters:
        `p` - Parsed used for reading JSON content
        `ctxt` - Context that can be used to access information about this deserialization activity.
      Returns:
        Deserialized value
      Throws:
        `IOException`

    - #### deserialize

          public EnumSet<?> deserialize(JsonParser p,
                                        DeserializationContext ctxt,
                                        EnumSet<?> result)
                                 throws IOException

      Description copied from class: `JsonDeserializer`
      Alternate deserialization method (compared to the most commonly used, `JsonDeserializer.deserialize(JsonParser, DeserializationContext)`), which takes in initialized value instance, to be configured and/or populated by deserializer. Method is not necessarily used (or supported) by all types (it will not work for immutable types, for obvious reasons): most commonly it is used for Collections and Maps. It may be used both with "updating readers" (for POJOs) and when Collections and Maps use "getter as setter".

      Default implementation just throws `UnsupportedOperationException`, to indicate that types that do not explicitly add support do not necessarily support update-existing-value operation (esp. immutable types)

      Overrides:
        `deserialize` in class `JsonDeserializer<EnumSet<?>>`
      Throws:
        `IOException`

    - #### _deserialize

          protected final EnumSet<?> _deserialize(JsonParser p,
                                                  DeserializationContext ctxt,
                                                  EnumSet result)
                                           throws IOException

      Throws:
        `IOException`

    - #### deserializeWithType

          public Object deserializeWithType(JsonParser p,
                                            DeserializationContext ctxt,
                                            TypeDeserializer typeDeserializer)
                                     throws IOException,
                                            JsonProcessingException

      Description copied from class: `StdDeserializer`
      Base implementation that does not assume specific type inclusion mechanism. Sub-classes are expected to override this method if they are to handle type information.
      Overrides:
        `deserializeWithType` in class `StdDeserializer<EnumSet<?>>`
        `typeDeserializer` - Deserializer to use for handling type information
      Throws:
        `IOException`
        `JsonProcessingException`

    - #### handleNonArray

          protected EnumSet<?> handleNonArray(JsonParser p,
                                              DeserializationContext ctxt,
                                              EnumSet result)
                                       throws IOException

      Throws:
        `IOException`

Copyright © 2008–2018 FasterXML. All rights reserved.